package com.kuxuan.laraver.activities;

import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v7.widget.ContentFrameLayout;

import com.diabin.latte.R;
import com.kuxuan.laraver.delegates.LatteDelegate;

import me.yokeyword.fragmentation.SupportActivity;

/**
 *
 * @author huangfuruixin
 * @date 2017/12/5
 */

public abstract class ProxyActivity extends SupportActivity{
    /**
     * 返回主 delegate
     * @return 返回主 delegate
     */
    public abstract LatteDelegate setRootDelegate();

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        initContainer(savedInstanceState);
    }

    private void initContainer(@Nullable Bundle savedInstanceState){
        final ContentFrameLayout container = new ContentFrameLayout(this);
        container.setId(R.id.delegate_container);
        setContentView(container);
        //如果是第一次
        if(savedInstanceState==null){
            loadRootFragment(R.id.delegate_container,setRootDelegate());
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        //垃圾回收
        System.gc();
        System.runFinalization();

    }
}
